SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Magnitude subclass: #Measure
	instanceVariableNames: 'unit amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 20:23'!
celsius: anAmount

	^self new initializeWithUnit: MeasureDerivedUnit celsius andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 21:03'!
centimeters: anAmount

	^self new initializeWithUnit: MeasureDerivedUnit centimeter andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 23:56'!
cubicMeters: anAmount

	^self new initializeWithUnit: MeasureBaseUnit cubicMeter andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:51'!
days: anAmount

	^self new initializeWithUnit: MeasureDerivedUnit day andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 21:07'!
fahrenheits: anAmount

	^self new initializeWithUnit: MeasureDerivedUnit fahrenheit andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:51'!
hours: anAmount

	^self new initializeWithUnit: MeasureDerivedUnit hour andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 10:43'!
kelvins: anAmount

	^self new initializeWithUnit: MeasureBaseUnit kelvin andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 20:22'!
meters: anAmount

	^self new initializeWithUnit: MeasureBaseUnit meter andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:50'!
metersPerSeconds: anAmount
	
	^self new initializeWithUnit: (DivideMeasureUnit meterPerSecond) andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:47'!
metersTimesSeconds: anAmount
	
	^self new initializeWithUnit: (MultiplyMeasureUnit meterTimesSecond) andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 21:04'!
minutes: anAmount

	^self new initializeWithUnit: MeasureDerivedUnit minute andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 20:22'!
seconds: anAmount

	^self new initializeWithUnit: MeasureBaseUnit second andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 23:53'!
squaredMeters: anAmount

	^self new initializeWithUnit: MeasureBaseUnit squaredMeter andAmount: anAmount! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 23:57'!
squaredSeconds: anAmount

	^self new initializeWithUnit: MeasureBaseUnit squaredSecond andAmount: anAmount! !

!Measure methodsFor: 'operations' stamp: 'LucianoLeveroni 5/27/2013 01:30'!
* aMeasureOrANumber

	^(aMeasureOrANumber isKindOf: Measure) 
		ifTrue: [ self multiplyWith:  aMeasureOrANumber ]
		ifFalse: [ self scaleWithValue: aMeasureOrANumber ]
		
	! !

!Measure methodsFor: 'operations' stamp: 'AgustinMosteiro 5/24/2013 20:47'!
+ aMeasure
"Returns a new measure instance with the same unit as the receiver and with the amount of the receiver plus the amount of the argument (in receivers unit)"

	(self sameBaseUnitAs: aMeasure) ifTrue: [
		^Measure new initializeWithUnit: unit andAmount: (amount + (unit convertFromBaseUnitAmount: (aMeasure amountInBaseUnit)))
	] ifFalse: [ Error signal ]! !

!Measure methodsFor: 'operations' stamp: 'AgustinMosteiro 5/25/2013 18:28'!
- aMeasure

	^self + aMeasure negated! !

!Measure methodsFor: 'operations' stamp: 'LucianoLeveroni 5/27/2013 01:33'!
/ aMeasureOrANumber

	^(aMeasureOrANumber isKindOf: Measure) 
		ifTrue: [ self divideWith:  aMeasureOrANumber ]
		ifFalse: [ self scaleWithValue: (1/aMeasureOrANumber) ]! !

!Measure methodsFor: 'comparing' stamp: 'AgustinMosteiro 5/26/2013 10:45'!
< aMeasure

	^self amountInBaseUnit < aMeasure amountInBaseUnit! !

!Measure methodsFor: 'comparing' stamp: 'LucianoLeveroni 5/27/2013 02:13'!
= aMeasure

	^(aMeasure isKindOf: self class) and: [ (self sameBaseUnitAs: aMeasure) and: [ self amountInBaseUnit = aMeasure amountInBaseUnit ] ]! !

!Measure methodsFor: 'accessing' stamp: 'AgustinMosteiro 5/20/2013 20:24'!
amount

	^amount! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/24/2013 20:15'!
amountInBaseUnit
"Returns amount in normalized value (base scale)"

	^unit convertAmountToBaseUnit: amount! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/24/2013 20:32'!
convertTo: aMeasureUnit
"The amount is updated in order to represent the same distance in the new unit, then the unit is also updated"

	(unit baseUnit = aMeasureUnit baseUnit) ifTrue: [
		amount := aMeasureUnit convertFromBaseUnitAmount: (self amountInBaseUnit).
		unit := aMeasureUnit
	] ifFalse: [ Error signal ]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:48'!
divideWith: anotherMeasure

	^(self sameBaseUnitDomainAs: anotherMeasure)
		ifTrue: [ 
			(unit exponent = anotherMeasure unit exponent) 
				ifTrue: [ amount / anotherMeasure amount ] 
				ifFalse: [ Measure new initializeWithUnit: (unit divideExponent: anotherMeasure unit exponent) andAmount: amount / anotherMeasure amount ]
		]
		ifFalse: [ Measure new initializeWithUnit: (DivideMeasureUnit new: unit per: anotherMeasure unit) andAmount: amount / anotherMeasure amount ]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:24'!
hash

	^self amountInBaseUnit hash.! !

!Measure methodsFor: 'initializers' stamp: 'AgustinMosteiro 5/25/2013 18:48'!
initializeWithUnit: aMeasureUnit andAmount: anAmount

	unit := aMeasureUnit.
	amount := anAmount! !

!Measure methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:47'!
multiplyWith: anotherMeasure

	^(self sameBaseUnitDomainAs: anotherMeasure)
		ifTrue: [ Measure new initializeWithUnit: (unit copy multiplyExponent: (anotherMeasure unit exponent)) andAmount: (amount * anotherMeasure amount) ]
		ifFalse: [ Measure new initializeWithUnit: (MultiplyMeasureUnit new: unit times: (anotherMeasure unit)) andAmount: (amount * anotherMeasure amount) ].! !

!Measure methodsFor: 'operations' stamp: 'AgustinMosteiro 5/20/2013 20:24'!
negated

	^self scaleWithValue: -1! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 21:33'!
printString

	^self unit = MeasureDerivedUnit celsius ifTrue: [ amount asString , ' celsius' ] ifFalse: [ amount asString , ' ' , unit printString asPluralBasedOn: amount ]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/24/2013 20:25'!
sameBaseUnitAs: aMeasure

	^unit baseUnit = aMeasure unit baseUnit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 00:20'!
sameBaseUnitDomainAs: aMeasure

	^unit baseUnit name = aMeasure unit baseUnit name! !

!Measure methodsFor: 'operations' stamp: 'AgustinMosteiro 5/25/2013 18:24'!
scaleWithValue: aNumber

	^Measure new initializeWithUnit: unit andAmount: (amount * aNumber)! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 10:56'!
to: aMeasure

	^MeasureInterval new initializeFrom: self to: aMeasure! !

!Measure methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 10:56'!
to: aMeasure by: anotherMeasure

	^MeasureInterval new initializeFrom: self to: aMeasure by: anotherMeasure! !

!Measure methodsFor: 'accessing' stamp: 'AgustinMosteiro 5/20/2013 20:24'!
unit

	^unit! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'AgustinMosteiro 5/23/2013 20:01'!
canNotConvertMeasurementException
	
	^Error! !

!MeasureTest methodsFor: 'temperature units' stamp: 'AgustinMosteiro 5/22/2013 20:16'!
celsius
	
	^MeasureDerivedUnit celsius! !

!MeasureTest methodsFor: 'distance units' stamp: 'AgustinMosteiro 5/22/2013 21:01'!
centimeter
	
	^MeasureDerivedUnit centimeter! !

!MeasureTest methodsFor: 'time units' stamp: 'AgustinMosteiro 5/22/2013 21:27'!
day
	
	^MeasureDerivedUnit day! !

!MeasureTest methodsFor: 'distance units' stamp: 'AgustinMosteiro 5/22/2013 21:16'!
decameter
	
	^MeasureDerivedUnit decameter! !

!MeasureTest methodsFor: 'distance units' stamp: 'AgustinMosteiro 5/22/2013 21:16'!
decimeter
	
	^MeasureDerivedUnit decimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'LucianoLeveroni 5/26/2013 23:56'!
eightCubicMeters

	^Measure cubicMeters: 8! !

!MeasureTest methodsFor: 'temperature units' stamp: 'AgustinMosteiro 5/22/2013 21:25'!
fahrenheit
	
	^MeasureDerivedUnit fahrenheit! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:40'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'LucianoLeveroni 5/26/2013 23:55'!
fourSquaredMeters

	^Measure squaredMeters: 4! !

!MeasureTest methodsFor: 'distance units' stamp: 'AgustinMosteiro 5/22/2013 21:16'!
hectometer
	
	^MeasureDerivedUnit hectometer! !

!MeasureTest methodsFor: 'time units' stamp: 'AgustinMosteiro 5/22/2013 21:27'!
hour
	
	^MeasureDerivedUnit hour! !

!MeasureTest methodsFor: 'temperature units' stamp: 'AgustinMosteiro 5/22/2013 21:35'!
kelvin
	
	^MeasureBaseUnit kelvin! !

!MeasureTest methodsFor: 'distance units' stamp: 'AgustinMosteiro 5/22/2013 21:16'!
kilometer
	
	^MeasureDerivedUnit kilometer! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'AgustinMosteiro 5/22/2013 20:16'!
meter

	^MeasureBaseUnit meter! !

!MeasureTest methodsFor: 'distance units' stamp: 'AgustinMosteiro 5/22/2013 21:15'!
millimeter
	
	^MeasureDerivedUnit millimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AgustinMosteiro 5/25/2013 18:27'!
minusOneMeter 
	
	^Measure meters: -1! !

!MeasureTest methodsFor: 'time units' stamp: 'AgustinMosteiro 5/22/2013 21:27'!
minute
	
	^MeasureDerivedUnit minute! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AgustinMosteiro 5/22/2013 20:23'!
oneCelsius
	
	^Measure celsius: 1! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AgustinMosteiro 5/22/2013 21:03'!
oneCentimeter
	
	^Measure centimeters: 1! !

!MeasureTest methodsFor: 'time measures' stamp: 'AgustinMosteiro 5/23/2013 19:52'!
oneDay
	
	^Measure days: 1! !

!MeasureTest methodsFor: 'time measures' stamp: 'AgustinMosteiro 5/23/2013 19:52'!
oneHour
	
	^Measure hours: 1! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AgustinMosteiro 5/22/2013 21:03'!
oneHundredCentimeters
	
	^Measure centimeters: 100! !

!MeasureTest methodsFor: 'compound measures' stamp: 'efo 5/2/2011 20:56'!
oneHundredTwentyOneMetersPerSecond

	^self error: 'este metodo debe devolver la medida 121 metro/segundo'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AgustinMosteiro 5/22/2013 20:23'!
oneMeter
	
	^Measure meters: 1! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:36'!
oneMeterPerSecond

	^self error: 'este metodo debe devolver la medida 1 metro/segundo'! !

!MeasureTest methodsFor: 'time measures' stamp: 'AgustinMosteiro 5/22/2013 21:08'!
oneMinute
	
	^Measure minutes: 1! !

!MeasureTest methodsFor: 'time measures' stamp: 'AgustinMosteiro 5/22/2013 20:23'!
oneSecond

	^Measure seconds: 1! !

!MeasureTest methodsFor: 'compound measures' stamp: 'AgustinMosteiro 5/25/2013 19:23'!
oneSquaredMeter

	^Measure squaredMeters: 1! !

!MeasureTest methodsFor: 'compound measures' stamp: 'LucianoLeveroni 5/26/2013 23:57'!
oneSquaredSecond

	^Measure squaredSeconds: 1! !

!MeasureTest methodsFor: 'time units' stamp: 'AgustinMosteiro 5/22/2013 20:17'!
second
	
	^MeasureBaseUnit second! !

!MeasureTest methodsFor: 'time measures' stamp: 'AgustinMosteiro 5/23/2013 19:53'!
sixtyMinutes
	
	^Measure minutes: 60! !

!MeasureTest methodsFor: 'time measures' stamp: 'AgustinMosteiro 5/24/2013 20:39'!
sixtyOneSeconds
	
	^Measure seconds: 61! !

!MeasureTest methodsFor: 'time measures' stamp: 'AgustinMosteiro 5/22/2013 20:58'!
sixtySeconds
	
	^Measure seconds: 60! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'AgustinMosteiro 5/22/2013 21:18'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'AgustinMosteiro 5/22/2013 21:28'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'AgustinMosteiro 5/26/2013 10:34'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AgustinMosteiro 5/22/2013 21:08'!
thirtyTwoFahrenheits
	
	^Measure fahrenheits: 32! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'AgustinMosteiro 5/23/2013 19:54'!
twentyFourHours
	
	^Measure hours: 24! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AgustinMosteiro 5/24/2013 20:39'!
twoCelsius
	
	^Measure celsius: 2! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AgustinMosteiro 5/22/2013 21:03'!
twoHundredCentimeters
	
	^Measure centimeters: 200! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AgustinMosteiro 5/22/2013 20:58'!
twoMeters
	
	^Measure meters: 2! !

!MeasureTest methodsFor: 'compound measures' stamp: 'LucianoLeveroni 5/27/2013 02:49'!
twoMetersBySecond

	^Measure metersPerSeconds: 2.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:33'!
twoMetersPerSquaredSecond

	^self error: 'este metodo debe devolver la medida 2 metros/segundoAlCuadrado'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'LucianoLeveroni 5/27/2013 00:45'!
twoMetersTimesSecond

	^Measure metersTimesSeconds: 2.! !

!MeasureTest methodsFor: 'time measures' stamp: 'AgustinMosteiro 5/24/2013 20:38'!
twoSeconds
	
	^Measure seconds: 2! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AgustinMosteiro 5/22/2013 20:59'!
zeroCelsius
	
	^Measure celsius: 0! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'AgustinMosteiro 5/26/2013 10:43'!
zeroKelvin
	
	^Measure kelvins: 0! !

!MeasureTest methodsFor: 'distance measures' stamp: 'AgustinMosteiro 5/25/2013 18:28'!
zeroMeters

	^Measure meters: 0! !

!MeasureTest methodsFor: 'time measures' stamp: 'AgustinMosteiro 5/24/2013 20:38'!
zeroSeconds
	
	^Measure seconds: 0! !

Object subclass: #MeasureInterval
	instanceVariableNames: 'from to by'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 10:46'!
do: aBlock

	| step |
	
	step := from.
	[step <= to] whileTrue: [ aBlock value: step. step := step + by ]
! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 10:57'!
first

	^ from! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 10:59'!
increment

	^ by! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 10:48'!
initializeFrom: aMeasure to: anotherMeasure

	from := aMeasure.
	to := anotherMeasure.
	by := Measure new initializeWithUnit: from unit andAmount: 1

	! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 10:48'!
initializeFrom: aMeasure to: anotherMeasure by: stepMeasure

	from := aMeasure.
	to := anotherMeasure.
	by := stepMeasure! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 10:57'!
last

	^ to! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 11:02'!
size
"The size of the interval is the intervals distance divided by the 'size' of the steps (by). The + 1 at the end is because both from and to are taken as steps."

	| intervalLength |
	
	intervalLength := to - from.
	^ ((intervalLength amountInBaseUnit) / (by amountInBaseUnit)) + 1! !

Object subclass: #MeasureUnit
	instanceVariableNames: 'name exponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

MeasureUnit subclass: #CompoundMeasureUnit
	instanceVariableNames: 'unit byUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundMeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:08'!
baseUnit

	^self subclassResponsibility! !

!CompoundMeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 00:55'!
byUnit

	^byUnit! !

!CompoundMeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:09'!
convertAmountToBaseUnit: anAmount
"To convert an amount in derived unit , the converter is used to return the amount in base unit"

	^self subclassResponsibility! !

!CompoundMeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 00:54'!
unit

	^unit! !

CompoundMeasureUnit subclass: #DivideMeasureUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DivideMeasureUnit class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:51'!
meterPerSecond

	^self new: MeasureBaseUnit meter per: MeasureBaseUnit second! !

!DivideMeasureUnit class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:11'!
new: aUnit per: anotherUnit

	^self new initializeWithUnit: aUnit per: anotherUnit! !

!DivideMeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:52'!
baseUnit

	^DivideMeasureUnit new: unit baseUnit per: byUnit baseUnit! !

!DivideMeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:09'!
convertAmountToBaseUnit: anAmount
"To convert an amount in derived unit , the converter is used to return the amount in base unit"

	^(unit convertAmountToBaseUnit: anAmount) / (byUnit convertAmountToBaseUnit: 1)! !

!DivideMeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:07'!
initializeWithUnit: aUnit per: anotherUnit

	name := aUnit name , ' per ' , anotherUnit name.
	exponent := 1.
	unit := aUnit.
	byUnit := anotherUnit! !

CompoundMeasureUnit subclass: #MultiplyMeasureUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MultiplyMeasureUnit class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:46'!
meterTimesSecond

	^self new: MeasureBaseUnit meter times: MeasureBaseUnit second! !

!MultiplyMeasureUnit class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:46'!
new: aUnit times: anotherUnit

	^self new initializeWithUnit: aUnit times: anotherUnit! !

!MultiplyMeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:48'!
baseUnit

	^MultiplyMeasureUnit new: unit baseUnit times: byUnit baseUnit! !

!MultiplyMeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:46'!
convertAmountToBaseUnit: anAmount
"To convert an amount in derived unit , the converter is used to return the amount in base unit"

	^(unit convertAmountToBaseUnit: anAmount) * (byUnit convertAmountToBaseUnit: 1)! !

!MultiplyMeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:46'!
initializeWithUnit: aUnit times: anotherUnit

	name := aUnit name , ' times ' , anotherUnit name.
	exponent := 1.
	unit := aUnit.
	byUnit := anotherUnit! !

MeasureUnit subclass: #MeasureBaseUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureBaseUnit class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 23:56'!
cubicMeter

	^self new initializeWithName: 'meter' andExponent: 3! !

!MeasureBaseUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 20:14'!
kelvin

	^self new initializeWithName: 'kelvin'! !

!MeasureBaseUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 20:11'!
meter

	^self new initializeWithName: 'meter'! !

!MeasureBaseUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 20:14'!
second

	^self new initializeWithName: 'second'! !

!MeasureBaseUnit class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 23:54'!
squaredMeter

	^self new initializeWithName: 'meter' andExponent: 2! !

!MeasureBaseUnit class methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 23:58'!
squaredSecond

	^self new initializeWithName: 'second' andExponent: 2! !

!MeasureBaseUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 20:26'!
baseUnit

	^self! !

!MeasureBaseUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/24/2013 20:18'!
convertAmountToBaseUnit: anAmount
"Converting an amount in base unit to base unit returns the same amount"

	^anAmount! !

!MeasureBaseUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/24/2013 20:19'!
convertFromBaseUnitAmount: anAmount
"Converting a base unit amount to base unit returns the same amount"

	^anAmount! !

!MeasureBaseUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 22:57'!
initializeWithName: aName

	name := aName.
	exponent := 1! !

!MeasureBaseUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 22:57'!
initializeWithName: aName andExponent: anSmallInteger

	name := aName.
	exponent := anSmallInteger! !

!MeasureBaseUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 23:07'!
initializeWithOneMoreDegree: aUnit

	^self initializeWithName: aUnit name andExponent: aUnit exponent + 1! !

!MeasureBaseUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:36'!
isBaseUnit

	^true! !

MeasureUnit subclass: #MeasureDerivedUnit
	instanceVariableNames: 'baseUnit baseUnitConverter baseUnitDeConverter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:32'!
celsius

	^self new initializeWithName: 'celsius' baseUnit: MeasureBaseUnit kelvin baseUnitConverter: [ :anAmount | anAmount + 273.15 ] andBaseUnitDeconverter: [ :anAmount | anAmount - 273.15 ]! !

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:33'!
centimeter

	^self new initializeWithName: 'centimeter' baseUnit: MeasureBaseUnit meter baseUnitConverter: [ :anAmount | anAmount / 100 ] andBaseUnitDeconverter: [ :anAmount | anAmount * 100 ]! !

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:33'!
day

	^self new initializeWithName: 'day' baseUnit: MeasureBaseUnit second baseUnitConverter: [ :anAmount | anAmount * 60 * 60 * 24 ] andBaseUnitDeconverter: [ :anAmount | anAmount / 60 / 60 / 24 ]! !

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:45'!
decameter

	^self new initializeWithName: 'decameter' baseUnit: MeasureBaseUnit meter baseUnitConverter: [ :anAmount | anAmount * 10 ] andBaseUnitDeconverter: [ :anAmount | anAmount / 10 ]! !

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:45'!
decimeter

	^self new initializeWithName: 'decimeter' baseUnit: MeasureBaseUnit meter baseUnitConverter: [ :anAmount | anAmount / 10 ] andBaseUnitDeconverter: [ :anAmount | anAmount * 10 ]! !

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:47'!
fahrenheit

	^self new initializeWithName: 'fahrenheit' baseUnit: MeasureBaseUnit kelvin baseUnitConverter: 
		[ :anAmount | (anAmount + 459.67) * 5/9 ] andBaseUnitDeconverter: [ :anAmount | (anAmount * 9/5) - 459.67  ]! !

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:47'!
hectometer

	^self new initializeWithName: 'hectometer' baseUnit: MeasureBaseUnit meter baseUnitConverter: [ :anAmount | anAmount * 100 ] andBaseUnitDeconverter: [ :anAmount | anAmount / 100 ]! !

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:48'!
hour

	^self new initializeWithName: 'hour' baseUnit: MeasureBaseUnit second baseUnitConverter: [ :anAmount | anAmount * 60 * 60 ] andBaseUnitDeconverter: [ :anAmount | anAmount / 60 / 60 ]! !

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:48'!
kilometer

	^self new initializeWithName: 'kilometer' baseUnit: MeasureBaseUnit meter baseUnitConverter: [ :anAmount | anAmount * 1000 ] andBaseUnitDeconverter: [ :anAmount | anAmount / 1000 ]! !

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:49'!
millimeter

	^self new initializeWithName: 'millimeter' baseUnit: MeasureBaseUnit meter baseUnitConverter: [ :anAmount | anAmount / 1000 ] andBaseUnitDeconverter: [ :anAmount | anAmount * 1000 ]! !

!MeasureDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:49'!
minute

	^self new initializeWithName: 'minute' baseUnit: MeasureBaseUnit second baseUnitConverter: [ :anAmount | anAmount * 60 ] andBaseUnitDeconverter: [ :anAmount | anAmount / 60 ]! !

!MeasureDerivedUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 20:26'!
baseUnit

	^baseUnit! !

!MeasureDerivedUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/24/2013 20:20'!
convertAmountToBaseUnit: anAmount
"To convert an amount in derived unit , the converter is used to return the amount in base unit"

	^baseUnitConverter value: anAmount! !

!MeasureDerivedUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/24/2013 20:21'!
convertFromBaseUnitAmount: anAmount
"To convert an amount in base unit to the derived unit the deconverter is used to return the given amount"

	^baseUnitDeConverter value: anAmount! !

!MeasureDerivedUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 22:58'!
initializeWithName: aName baseUnit: aBaseUnit baseUnitConverter: aBaseUnitConverter andBaseUnitDeconverter: aBaseUnitDeconverter

	name := aName.
	exponent := 1.
	baseUnit := aBaseUnit.
	baseUnitConverter := aBaseUnitConverter.
	baseUnitDeConverter := aBaseUnitDeconverter! !

!MeasureDerivedUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 22:59'!
initializeWithName: aName exponent: anSmallInteger baseUnit: aBaseUnit baseUnitConverter: aBaseUnitConverter andBaseUnitDeconverter: aBaseUnitDeconverter

	name := aName.
	exponent := anSmallInteger.
	baseUnit := aBaseUnit.
	baseUnitConverter := aBaseUnitConverter.
	baseUnitDeConverter := aBaseUnitDeconverter! !

!MeasureDerivedUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:36'!
isBaseUnit

	^false! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 23:45'!
= aMeasureUnit

	^(name = aMeasureUnit name) and: (exponent = aMeasureUnit exponent)! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/26/2013 10:42'!
adaptToInteger: aNumber andSend: selector

	^(Measure new initializeWithUnit: self andAmount: 1) perform: selector with: aNumber! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/22/2013 20:26'!
baseUnit

	^self subclassResponsibility! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/24/2013 20:12'!
convertAmountToBaseUnit: anAmount

	^self subclassResponsibility! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/24/2013 20:08'!
convertFromBaseUnitAmount: anAmount

	^self subclassResponsibility! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:15'!
divideExponent: anExponent

	exponent := exponent - anExponent! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 23:45'!
exponent

	^exponent! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/23/2013 19:35'!
isBaseUnit

	^self subclassResponsibility! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/27/2013 02:44'!
multiplyExponent: anExponent

	exponent := exponent + anExponent! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'LucianoLeveroni 5/26/2013 23:49'!
printOn: aStream 

	aStream nextPutAll: name! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'AgustinMosteiro 5/20/2013 20:24'!
printString

	^name! !
